
/** 
   Questa classe rappresenta il generico nodo
   di un albero binario di ricerca
*/

public class BSTNode {
	protected Persona elemento;
	protected Comparable key; 
	/* interface Comparable richiede metodo compareTo */
	BSTNode left, right; /* Figli destro e sinistro */
	/**
		Costruttori
	*/
	public BSTNode() {
		left = right = null;
	}
	public BSTNode(Persona el, Comparable key) {
		elemento = el;
		this.key = key;
		left = right = null;
	}
	public BSTNode(Persona el, Comparable key, BSTNode lt, BSTNode rt) {
		elemento = el;
		this.key = key;
		left = lt;
		right = rt;
	}
	public void visit() { 
		elemento.visit(); 
	}
	public boolean isLeaf() {
		return ((left == null) && (right == null));
	}
}

