import java.io.*;
import java.util.*;

public class BSTTest {
	public final static int MAXNUM = 10000;
	private static ConsoleReader lettore;
	private static BufferedReader dataFile;
	public BSTTest() throws IOException {
		 lettore = new ConsoleReader(System.in);
	}
	
	public static void main(String args[]) throws IOException {
		int scelta;
		BSTree myBSTree = new BSTree();	

		new BSTTest();
		System.out.println("Starting BST test...");
		do {
			menu();
			scelta = lettore.readInt();
			lancia(scelta, myBSTree);
		} while(scelta != 0);
		System.out.println("Ciao!!");
	}
	
	private static void menu() {
		System.out.println(" [0] Uscita");
		System.out.println(" [1] Carica i dati da file");		
		System.out.println(" [2] Inserisci una persona");
		System.out.println(" [3] Stampa i dati di una persona dati cognome e nome ");
		System.out.println(" [4] Verifica se una persona si trova nella base di dati");
		System.out.println(" [5] Cancella i dati di una persona");
		System.out.println(" [6] Stampa i dati di tutte le persone, in ordine alfabetico");
		System.out.println(" [7] Stampa il numero di persone registrate");
		System.out.println(" [8] Svuota l'archivio");	
	}
	
	private static void lancia(int s, BSTree myBSTree) throws IOException { 
		switch(s) {
			case 1: // Carica i dati dal file "inputfile"
					dataFile = new BufferedReader(new FileReader("inputfile.txt"));
					String datiPers = dataFile.readLine();
					StringTokenizer st;
					while(datiPers != null) {
						st = new StringTokenizer(datiPers, ";");
						Persona nuovaPersona = new Persona(null, null, null);
						nuovaPersona.cognomeNome = st.nextToken();
						nuovaPersona.CF = st.nextToken();
						nuovaPersona.indirizzo = st.nextToken();						
						myBSTree.insert(new BSTNode(nuovaPersona, nuovaPersona.cognomeNome));
						datiPers = dataFile.readLine();
					}						
					dataFile.close();
					break;
			case 2: // Inserisce una nuova persona
					System.out.print("<Cognome> <Nome>: ");
					String cognomeNome = lettore.readLine();
					System.out.println();
					System.out.print("Codice fiscale: ");
					String CF = lettore.readLine();
					System.out.println();
					System.out.print("Indirizzo: ");
					String indirizzo = lettore.readLine();
					System.out.println();
					Persona newPers = new Persona(cognomeNome, CF, indirizzo);
					myBSTree.insert(new BSTNode(newPers, cognomeNome));
			        break;
			case 3: // Stampa i dati di una persona dati Cognome e Nome
					System.out.print("<Cognome> <Nome>: ");
					cognomeNome = lettore.readLine();
					if (myBSTree.isInTree(cognomeNome)) {
						Persona personaDaTrovare = (myBSTree.search(myBSTree.root, cognomeNome)).elemento;
						System.out.println("Codice fiscale: " + personaDaTrovare.CF + " " + "Indirizzo: " + personaDaTrovare.indirizzo);
					}
					else
						System.out.println("Assente !!");
			        break;
			case 4: // Verifica se una persona si trovi nella base di dati 
					System.out.print("<Cognome> <Nome>: ");
					cognomeNome = lettore.readLine();
					if (myBSTree.isInTree(cognomeNome))
						System.out.println("Trovato/a !!");
					else 
						System.out.println("Assente !!");
			        break;
			case 5: // Cancella i dati di una persona dati cognome e nome
					System.out.print("<Cognome> <Nome>: ");
					cognomeNome = lettore.readLine();
					if (myBSTree.isInTree(cognomeNome)) {
						myBSTree.delete(cognomeNome);
						System.out.println("Cancellato/a !!");
					}
					else 
						System.out.println("Nominativo assente !!");
			
					break;

			case 6: /** Visita in ordine simmetrico per stampare 
						i nomi di tutte le persone registrate */
					myBSTree.treeInorder(myBSTree.root);
					break;
			case 7: // Stampa il numero di persone registrate
					System.out.println("Il numero di persone registrate e' " + myBSTree.size);
					break;
			case 8: // Svuota l'archivio
					myBSTree.clear();
					System.out.println("L'archivio  vuoto");
					break;
		}		
	} /* End lancia() */
} 