

/** 
   Questa classe implementa un albero binario di ricerca.
   Sono stati implementati solamente alcuni dei metodi
   dell'interfaccia omonima vista a lezione. 
*/

public class BSTree {
	protected BSTNode root;
	protected int size = 0; /* No. di elementi */
	/* Costruttore */
	BSTree() {
		root = null;
	}
	
	protected void clear() {
		root = null;
		size = 0;
	}
		
	public boolean isEmpty() {
		return (root == null);
	}
	
	/** search implementa una ricerca binaria */
	public BSTNode search(BSTNode p, Comparable el) {
		while (p != null)
            if (el.equals(p.key))
                 return p;
            else if (el.compareTo(p.key) < 0)
                 p = p.left;
            else p = p.right;
    	return null; /* Se non lo trova */
	}
	
	/** Inserimento */
	protected void insert(BSTNode node){
        BSTNode p = root, prev = null;
        while (p != null) {
			prev = p;
            if (p.key.compareTo(node.key) < 0)
                 p = p.right;
            else p = p.left;
        }
        if (root == null) // albero vuoto;
             root = node;
        else if (prev.key.compareTo(node.key) < 0)
             prev.right = node;
        else prev.left  = node;
        size++;
    }
		
	public boolean isInTree(Comparable el){
		return (search(root, el) != null);
	}
	
	/** Restituisce il No. di elementi */
	public int getSize(){
		return size;
	}
	
	/** Visita in ordine simmetrico */
	void treeInorder(BSTNode p) {
		if(p == null) 
			return;
		treeInorder(p.left);
		p.visit();
		treeInorder(p.right);
	}
	
	/** Esegue la cancellazione usando il metodo
		basato sulla copiatura
	*/
	void delete(Comparable el) {
		BSTNode node, p = root, prev = null;
  
		/* Cerca il nodo */
  		while (p != null && !p.key.equals(el)) {
			prev = p; 
			if (p.key.compareTo(el)<0)
            	p = p.right;
      		else p = p.left;
  		}
  		node = p;
  		/* Casi semplici: il nodo ha un solo figlio */
		if (p != null && p.key.equals(el)) {
			size--; /* Decrementa No. nodi */
  			if (node.right == null) 
				node = node.left;
      		else if (node.left == null) 
				node = node.right;
			else { /* Due figli .... */		
  				BSTNode tmp = node.left; 
				BSTNode previous = node;
				/** Cerca il nodo da copiare */
      			while (tmp.right != null) {
					previous = tmp; 
					tmp = tmp.right; 
			    }
	  			node.key = tmp.key; 
	  			node.elemento = tmp.elemento;
				if (previous == node) 
					previous.left = tmp.left; 
				else 
					previous.right = tmp.left; 
			}   		
			if (p == root) /* Trova padre nuovo nodo */
  				root = node;
	  		else if (prev.left == p)
	      		prev.left = node;
	  		else 	
	  			prev.right = node;
  		} /* End if */
  		else if (root != null)
  			System.out.println("Elemento assente ");
  		else 
  			System.out.println("Albero vuoto");
  	}
}
			
		



